<?php
function _newsletterUpdate()
{
	global $objDatabase, $_CONFIG, $objUpdate, $_ARRAYLANG;

	$arrColumns = $objDatabase->MetaColumns(DBPREFIX.'module_newsletter');
	if ($arrColumns === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter'));
		return false;
	}

	// update attribute contrexx_module_newsletter.date_sent
	if ($arrColumns['DATE_SENT']->type == 'date') {
		$arrNewsletters = array();

		$query = "SELECT id, date_sent FROM ".DBPREFIX."module_newsletter";
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$arrNewsletters[$objResult->fields['id']] = mktime(0, 0, 0, substr($objResult->fields['date_sent'], 5, 2), substr($objResult->fields['date_sent'], 8, 2), substr($objResult->fields['date_sent'], 0, 4));
				$objResult->MoveNext();
			}

			$query = "ALTER TABLE ".DBPREFIX."module_newsletter CHANGE `date_sent` `date_sent` INT( 14 ) UNSIGNED NOT NULL DEFAULT '0'";
			if ($objDatabase->Execute($query) !== false) {
				if (count($arrNewsletters) > 0) {
					foreach ($arrNewsletters as $newsletterId => $dateSent) {
						$query = "UPDATE ".DBPREFIX."module_newsletter SET `date_sent`=".$dateSent." WHERE id=".$newsletterId;
						if ($objDatabase->Execute($query) === false) {
							return _databaseError($query, $objDatabase->ErrorMsg());
						}
					}
				}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	// update attribute contrexx_module_newsletter.date_create
	if ($arrColumns['DATE_CREATE']->type == 'date') {
		$arrNewsletters = array();

		$query = "SELECT id, date_create FROM ".DBPREFIX."module_newsletter";
		$objResult = $objDatabase->Execute($query);

		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$arrNewsletters[$objResult->fields['id']] = mktime(0, 0, 0, substr($objResult->fields['date_create'], 5, 2), substr($objResult->fields['date_create'], 8, 2), substr($objResult->fields['date_create'], 0, 4));
				$objResult->MoveNext();
			}

			$query = "ALTER TABLE ".DBPREFIX."module_newsletter CHANGE `date_create` `date_create` INT( 14 ) UNSIGNED NOT NULL DEFAULT '0'";
			if ($objDatabase->Execute($query) !== false) {
				if (count($arrNewsletters) > 0) {
					foreach ($arrNewsletters as $newsletterId => $dateCreate) {
						$query = "UPDATE ".DBPREFIX."module_newsletter SET `date_create`=".$dateCreate." WHERE id=".$newsletterId;
						if ($objDatabase->Execute($query) === false) {
							return _databaseError($query, $objDatabase->ErrorMsg());
						}
					}
				}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX.'module_newsletter');
	if ($arrIndexes !== false) {
		if (isset($arrIndexes['id'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter` DROP INDEX `id`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter'));
		return false;
	}

	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (in_array(DBPREFIX."module_newsletter_config", $arrTables)) {
		if (!in_array(DBPREFIX."module_newsletter_settings", $arrTables)) {
			$query ="CREATE TABLE ".DBPREFIX."module_newsletter_settings (`setid` smallint(6) NOT NULL auto_increment,`setname` varchar(250) NOT NULL default '',`setvalue` text NOT NULL,`status` tinyint(1) NOT NULL default '0',PRIMARY KEY  (`setid`)) ENGINE=MyISAM";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		$query = "SELECT sender_email, sender_name, return_path, mails_per_run FROM ".DBPREFIX."module_newsletter_config";
		$objConfig = $objDatabase->Execute($query);
		if ($objConfig !== false) {
			$arrConfig = array(
				'sender_mail'				=> $objConfig->fields['sender_email'],
				'sender_name'				=> $objConfig->fields['sender_name'],
				'reply_mail'				=> $objConfig->fields['return_path'],
				'mails_per_run'				=> $objConfig->fields['mails_per_run'],
				'text_break_after'			=> 100,
				'test_mail'					=> '',
				'overview_entries_limit'	=> '10'
			);
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		foreach ($arrConfig as $property => $value) {
			$query = "SELECT setid FROM ".DBPREFIX."module_newsletter_settings WHERE setname='".$property."'";
			$objConfig = $objDatabase->SelectLimit($query, 1);
			if ($objConfig !== false) {
			 	if ($objConfig->RecordCount() == 0) {
					$query = "INSERT INTO ".DBPREFIX."module_newsletter_settings (`setname`, `setvalue`, `status`) VALUES ('".$property."', '".contrexx_addslashes($value)."', 1)";
					if ($objDatabase->Execute($query) === false) {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
			 	}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		$query = "DROP TABLE ".DBPREFIX."module_newsletter_config";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_newsletter_settings WHERE setname='rejected_mail_operation'";
	$objConfig = $objDatabase->SelectLimit($query, 1);
	if ($objConfig !== false) {
	 	if ($objConfig->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_newsletter_settings` (`setname`, `setvalue`, `status`) values ('rejected_mail_operation', 'ignore', '1')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
	 	}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter");
	if ($arrColumns !== false) {
		if (strpos($arrColumns['ATTACHMENT']->type, 'set') !== false) {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter CHANGE `attachment` `attachment` ENUM( '0', '1' ) NOT NULL DEFAULT '0'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		if (strpos($arrColumns['FORMAT']->type, 'set') !== false) {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter CHANGE `format` `format` ENUM( 'text', 'html', 'html/text' ) NOT NULL DEFAULT 'text'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter'));
		return false;
	}

	$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter_user");
	if ($arrColumns !== false) {
		if (!array_key_exists('TITLE', $arrColumns)) {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter_user ADD `title` ENUM( 'm', 'f' ) NULL AFTER `email`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		} else {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter_user CHANGE `title` `title` ENUM( 'm', 'f' ) NULL";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		if (!array_key_exists('COMPANY', $arrColumns)) {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter_user ADD `company` VARCHAR( 255 )NOT NULL DEFAULT '' AFTER `firstname`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		} else {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter_user CHANGE `company` `company` VARCHAR( 255 )NOT NULL DEFAULT ''";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		$query = "ALTER TABLE ".DBPREFIX."module_newsletter_user CHANGE `birthday` `birthday` VARCHAR( 10 )NOT NULL DEFAULT '00-00-0000'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		// update attribute contrexx_module_user.emaildate
		if ($arrColumns['EMAILDATE']->type == 'date') {
			$arrUsers = array();

			$query = "SELECT id, emaildate FROM ".DBPREFIX."module_newsletter_user";
			$objResult = $objDatabase->Execute($query);
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					$arrUsers[$objResult->fields['id']] = mktime(0, 0, 0, substr($objResult->fields['emaildate'], 5, 2), substr($objResult->fields['emaildate'], 8, 2), substr($objResult->fields['emaildate'], 0, 4));
					$objResult->MoveNext();
				}

				$query = "ALTER TABLE ".DBPREFIX."module_newsletter_user CHANGE `emaildate` `emaildate` INT( 14 ) UNSIGNED NOT NULL DEFAULT '0'";
				if ($objDatabase->Execute($query) !== false) {
					if (count($arrUsers) > 0) {
						foreach ($arrUsers as $userId => $registredDate) {
							$query = "UPDATE ".DBPREFIX."module_newsletter_user SET `emaildate`=".$registredDate." WHERE id=".$userId;
							if ($objDatabase->Execute($query) === false) {
								return _databaseError($query, $objDatabase->ErrorMsg());
							}
						}
					}
				} else {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_user'));
		return false;
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_newsletter_user");
	if ($arrIndexes !== false) {
		if (!isset($arrIndexes['email']['unique'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_user` ADD UNIQUE ( `email` )";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		if (isset($arrIndexes['emailadress'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_user` DROP INDEX `emailadress`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_user'));
		return false;
	}

	if (!in_array(DBPREFIX."module_newsletter_confirm_mail", $arrTables)) {
		$query = "CREATE TABLE ".DBPREFIX."module_newsletter_confirm_mail (
			`id` INT( 1 ) NOT NULL AUTO_INCREMENT ,
			`title` VARCHAR( 255 ) NOT NULL DEFAULT '',
			`content` LONGTEXT NOT NULL ,
			PRIMARY KEY ( `id` )
			)";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_newsletter_confirm_mail` CHANGE `title` `title` VARCHAR( 255 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_newsletter_category");
	if ($arrIndexes !== false) {
		if (isset($arrIndexes['id'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_category` DROP INDEX `id`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		if (!isset($arrIndexes['name'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_category` ADD INDEX ( `name` )";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_category'));
		return false;
	}

	$query = "SELECT id,title,content FROM ".DBPREFIX."module_newsletter_confirm_mail WHERE id='1'";
	$objCheckConfim = $objDatabase->SelectLimit($query,1);
	if ($objCheckConfim) {
		if ($objCheckConfim->RecordCount() == 0) {
			//insert confirm mail
			$query = "INSERT INTO `".DBPREFIX."module_newsletter_confirm_mail` ( `id` , `title` , `content` ) VALUES (1, '[[url]] Newsletteraktivierung', 'Guten Tag [[sex]] [[lastname]] Ihre E-Mail Adresse wurde erfolgreich in unserer Newsletter Datenbank abgespeichert. Um Ihre E-Mail Adresse zu aktivieren, benutzen Sie bitte folgenden Link: [[code]] Mit freundlichen Grssen [[url]] - Team Automatisch generierte Nachricht [[date]]')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT id,title,content FROM ".DBPREFIX."module_newsletter_confirm_mail WHERE id='2'";
	$objCheckConfim = $objDatabase->SelectLimit($query,1);
	if ($objCheckConfim) {
		if ($objCheckConfim->RecordCount() == 0) {
			//insert confirm mail
			$query = "INSERT INTO `".DBPREFIX."module_newsletter_confirm_mail` ( `id` , `title` , `content` ) VALUES (2, '[[url]] Newsletteraktivierung erfolgreich', 'Guten Tag [[sex]] [[lastname]] Ihre E-Mail Adresse wurde erfolgreich in unsererm Newsletter-System aktiviert. Sie werden nun in Zukunft unsere Newsletter erhalten Mit freundlichen Grssen [[url]] - Team Automatisch generierte Nachricht [[date]]')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	//replace for confirm mail
	$query = "SELECT id,title,content FROM ".DBPREFIX."module_newsletter_confirm_mail";
	$objResult = $objDatabase->Execute($query);
	if ($objResult !== false) {
		while (!$objResult->EOF) {
			$id 		= $objResult->fields['id'];
			$subject 	= $objResult->fields['title'];
			$content 	= $objResult->fields['content'];

			//with spacer
			$array_1 = array('<-- title -->', '[[title]]', '<-- firstname -->', '<-- lastname -->', '<-- code -->', '<-- url -->', '<-- date -->');
			$array_2 = array('[[sex]]', '[[sex]]','[[firstname]]', '[[lastname]]', '[[code]]', '[[url]]', '[[date]]');
			$mailTitle = str_replace($array_1, $array_2, $subject);
			$mailContent = str_replace($array_1, $array_2, $content);

			//without spacer
			$array_3 = array('<--title-->', '[[title]]','<--firstname-->', '<--lastname-->', '<--code-->', '<--url-->', '<--date-->');
			$array_4 = array('[[sex]]', '[[sex]]','[[firstname]]', '[[lastname]]', '[[code]]', '[[url]]', '[[date]]');
			$mailTitle = str_replace($array_3, $array_4, $mailTitle);
			$mailContent = str_replace($array_3, $array_4, $mailContent);

			//update
			$query = "UPDATE ".DBPREFIX."module_newsletter_confirm_mail SET title='".addslashes($mailTitle)."', content='".addslashes($mailContent)."' where id='".$id."'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}

			$objResult->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}


	//replace for templates
	$query = "SELECT id,description,html,text FROM ".DBPREFIX."module_newsletter_template";
	$objResult = $objDatabase->Execute($query );
	if ($objResult !== false) {
		while (!$objResult->EOF) {
			$id 		= $objResult->fields['id'];
			$html 		= $objResult->fields['html'];
			$text 		= $objResult->fields['text'];

			//with spacer
			$array_1 = array('<-- subject -->', '<-- email -->', '<-- title -->', '<-- lastname -->', '<-- firstname -->', '<-- street -->', '<-- zip -->', '<-- city -->', '<-- country -->', '<-- phone -->', '<-- birthday -->', '<-- content -->', '<-- profile_setup -->', '<-- unsubscribe -->', '<-- date -->');
			$array_2 = array('[[subject]]', '[[email]]', '[[title]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]', '[[content]]', '[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$newHtml = str_replace($array_1, $array_2, $html);
			$newText = str_replace($array_1, $array_2, $text);

			//without spacer
			$array_3 = array('<--subject-->', '<--email-->', '<--title-->', '<--lastname-->', '<--firstname-->', '<--street-->', '<--zip-->', '<--city-->', '<--country-->', '<--phone-->', '<--birthday-->', '<--content-->', '<--profile_setup-->', '<--unsubscribe-->', '<--date-->');
			$array_4 = array('[[subject]]', '[[email]]', '[[title]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]', '[[content]]', '[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$newHtml = str_replace($array_3, $array_4, $newHtml);
			$newText = str_replace($array_3, $array_4, $newText);

			//update
			$query = "UPDATE ".DBPREFIX."module_newsletter_template SET html='".addslashes($newHtml)."', text='".addslashes($newText)."' where id='".$id."'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}

			$objResult->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	//replace for templates
	$query = "SELECT id,content,content_text FROM ".DBPREFIX."module_newsletter";
	$objResult = $objDatabase->Execute($query );
	if ($objResult !== false) {
		while (!$objResult->EOF) {
			$id 		= $objResult->fields['id'];
			$html 		= $objResult->fields['content'];
			$text 		= $objResult->fields['content_text'];

			//with spacer
			$array_1 = array('<-- subject -->', '<-- email -->', '<-- title -->', '<-- lastname -->', '<-- firstname -->', '<-- street -->', '<-- zip -->', '<-- city -->', '<-- country -->', '<-- phone -->', '<-- birthday -->', '<-- content -->', '<-- profile_setup -->', '<-- unsubscribe -->', '<-- date -->');
			$array_2 = array('[[subject]]','[[email]]', '[[sex]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]', '[[content]]', '[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$newHtml = str_replace($array_1, $array_2, $html);
			$newText = str_replace($array_1, $array_2, $text);

			//without spacer
			$array_3 = array('<--subject-->','<--email-->', '<--title-->', '<--lastname-->', '<--firstname-->', '<--street-->', '<--zip-->', '<--city-->', '<--country-->', '<--phone-->', '<--birthday-->', '<--content-->', '<--profile_setup-->', '<--unsubscribe-->', '<--date-->');
			$array_4 = array('[[subject]]','[[email]]', '[[sex]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]', '[[content]]', '[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$newHtml = str_replace($array_3, $array_4, $newHtml);
			$newText = str_replace($array_3, $array_4, $newText);

			//with spacer and htmlspecialchars
			$array_1 = array('&lt;-- subject --&gt;', '&lt;-- email --&gt;', '&lt;-- title --&gt;', '&lt;-- lastname --&gt;', '&lt;-- firstname --&gt;', '&lt;-- street --&gt;', '&lt;-- zip --&gt;', '&lt;-- city --&gt;', '&lt;-- country --&gt;', '&lt;-- phone --&gt;', '&lt;-- birthday --&gt;', '&lt;-- content --&gt;', '&lt;-- profile_setup --&gt;', '&lt;-- unsubscribe --&gt;', '&lt;-- date --&gt;');
			$array_2 = array('[[subject]]', '[[email]]', '[[sex]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]', '[[content]]', '[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$newHtml = str_replace($array_1, $array_2, $newHtml);
			$newText = str_replace($array_1, $array_2, $newText);

			//without spacer and htmlspecialchars
			$array_3 = array('&lt;--subject--&gt;', '&lt;--email--&gt;', '&lt;--title--&gt;', '&lt;--lastname--&gt;', '&lt;--firstname--&gt;', '&lt;--street--&gt;', '&lt;--zip--&gt;', '&lt;--city--&gt;', '&lt;--country--&gt;', '&lt;--phone--&gt;', '&lt;--birthday--&gt;', '&lt;--content--&gt;', '&lt;--profile_setup--&gt;', '&lt;--unsubscribe--&gt;', '&lt;--date--&gt;');
			$array_4 = array('[[subject]]', '[[email]]', '[[sex]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]', '[[content]]', '[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$newHtml = str_replace($array_3, $array_4, $newHtml);
			$newText = str_replace($array_3, $array_4, $newText);

			if ($objUpdate->_isNewerVersion($_CONFIG['coreCmsVersion'], '1.1.0')) {
				$newHtml = str_replace('[[title]]', '[[sex]]', $newHtml);
				$newText = str_replace('[[title]]', '[[sex]]', $newText);
			}

			//update
			$query = "UPDATE ".DBPREFIX."module_newsletter SET content='".addslashes($newHtml)."', content_text='".addslashes($newText)."' where id='".$id."'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}

			$objResult->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// add required attribute to table contrexx_module_newsletter_template
	$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter_template");
	if ($arrColumns !== false) {
		if (!isset($arrColumns['REQUIRED'])) {
			$query = "ALTER TABLE ".DBPREFIX."module_newsletter_template ADD `required` INT( 1 ) NOT NULL DEFAULT '0'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_template'));
		return false;
	}

	//template update table
	$query = "SELECT id FROM ".DBPREFIX."module_newsletter_template WHERE required=1";
	$objTemplates = $objDatabase->SelectLimit($query, 1);
	if ($objTemplates !== false) {
		if ($objTemplates->RecordCount() == 0) {
			$query = "SELECT id FROM ".DBPREFIX."module_newsletter_template";
			$objTemplates = $objDatabase->SelectLimit($query, 1);
			if ($objTemplates !== false) {
				if ($objTemplates->RecordCount() == 0) {
					$query = "INSERT INTO ".DBPREFIX."module_newsletter_template (`name`, `description`, `html`, `text`, `required`) VALUES ('Standard', 'Standard Template', '<html><head><title>[[subject]]</title></head><body>[[content]]<br /><br />[[profile_setup]][[unsubscribe]]</body></html>', '[[content]][[profile_setup]][[unsubscribe]]', 1)";
					if ($objDatabase->Execute($query) === false) {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				} else {
					$query = "UPDATE ".DBPREFIX."module_newsletter_template SET `required`=1 WHERE id = ".$objTemplates->fields['id'];
					if ($objDatabase->Execute($query) === false) {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				}
			} else {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}

		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	// reassociate the $arrColumns array due to the reassignement of the primary key caused by the drop statement before
	$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter_rel_cat_news");
	if ($arrColumns !== false) {
		if (isset($arrColumns['ID'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_rel_cat_news` DROP `id`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		$query = "DELETE FROM `".DBPREFIX."module_newsletter_rel_cat_news` WHERE `newsletter` = '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter_rel_cat_news");
		if ($arrColumns === false) {
			setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_rel_cat_news'));
			return false;
		}

		$key = array();
		foreach ($arrColumns as $column) {
			if (!empty($column->primary_key)) {
				$key[] = $column->name;
			}
		}

		if (count($key) == 0) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_rel_cat_news` ADD PRIMARY KEY ( `newsletter` , `category` )";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_rel_cat_news'));
		return false;
	}

	// update structure of table contrexx_module_newsletter_rel_user_cat
	$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter_rel_user_cat");
	if ($arrColumns !== false) {
		if (isset($arrColumns['ID'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_rel_user_cat` DROP `id`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_rel_user_cat'));
		return false;
	}

	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_newsletter_rel_user_cat");
	if ($arrIndexes !== false) {
		if (isset($arrIndexes['user'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_rel_user_cat` DROP INDEX `user`";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_rel_user_cat'));
		return false;
	}

	// reassociate the $arrColumns array due to the reassignement of the primary key caused by the drop statement before
	$arrColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter_rel_user_cat");
	if ($arrColumns !== false) {
		$key = array();
		foreach ($arrColumns as $column) {
			if (!empty($column->primary_key)) {
				$key[] = $column->name;
			}
		}

		if (count($key) == 0) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_rel_user_cat` ADD PRIMARY KEY ( `user` , `category` )";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_rel_user_cat'));
		return false;
	}

	// update structure of table contrexx_module_newsletter_user
	$arrIndexes = $objDatabase->MetaIndexes(DBPREFIX."module_newsletter_user");
	if ($arrIndexes !== false) {
		if (!isset($arrIndexes['status'])) {
			$query = "ALTER TABLE `".DBPREFIX."module_newsletter_user` ADD INDEX ( `status` )";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_user'));
		return false;
	}

	$arrTables = array();
	$arrTables = $objDatabase->MetaTables('TABLES');


	if (!in_array(DBPREFIX.'module_newsletter_system', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_newsletter_system` (
				  `sysid` int(7) NOT NULL auto_increment,
				  `sysname` varchar(255) NOT NULL default '',
				  `sysvalue` varchar(255) NOT NULL default '',
				  `type` int(1) NOT NULL default '0',
				  PRIMARY KEY  (`sysid`)
				) ENGINE=MyISAM";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT sysid FROM ".DBPREFIX."module_newsletter_system WHERE sysid='1'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck->RecordCount() == 0) {
		$query = 	"INSERT INTO `".DBPREFIX."module_newsletter_system` ( `sysid` , `sysname` , `sysvalue` , `type` )
					VALUES (
					NULL , 'defUnsubscribe', '1', '1'
					)";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

    $query = "
    ALTER TABLE ".DBPREFIX."module_newsletter_settings
    CHANGE COLUMN setid setid integer(6) UNSIGNED NOT NULL auto_increment
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

    $arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_newsletter");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter'));
		return false;
	}

	if (!in_array('smtp_server', $arrColumns)) {
	    $query = "ALTER TABLE `".DBPREFIX."module_newsletter` ADD `smtp_server` INT UNSIGNED NOT NULL AFTER `return_path`";
	    if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	// add customizable titles
	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (!in_array(DBPREFIX."module_newsletter_user_title", $arrTables)) {
		$query ="CREATE TABLE `".DBPREFIX."module_newsletter_user_title` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`title` VARCHAR( 255 ) NOT NULL ,
			UNIQUE ( `title` )
			) ENGINE = MYISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrTitleFields = array(
		'Sehr geehrte Frau'		=> 'f',
		'Sehr geehrter Herr'	=> 'm'
	);

	foreach (array_keys($arrTitleFields) as $field) {
		$query = "SELECT 1 FROM `".DBPREFIX."module_newsletter_user_title` WHERE `title` = '".$field."'";
		$objTitle = $objDatabase->SelectLimit($query, 1);
		if ($objTitle !== false) {
			if ($objTitle->RecordCount() == 0) {
				$query = "INSERT INTO `".DBPREFIX."module_newsletter_user_title` (`title`) VALUES ('".$field."')";
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumns(DBPREFIX.'module_newsletter_user');
	if ($arrColumns === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_user'));
		return false;
	}

	if (!isset($arrColumns['SEX'])) {
		$query = "ALTER TABLE `".DBPREFIX."module_newsletter_user` CHANGE `title` `sex` ENUM( 'm', 'f' ) NULL DEFAULT NULL";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumns(DBPREFIX.'module_newsletter_user');
	if ($arrColumns === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_newsletter_user'));
		return false;
	}

	if (!isset($arrColumns['TITLE'])) {
		$query = "ALTER TABLE `".DBPREFIX."module_newsletter_user` ADD `title` INT UNSIGNED NOT NULL AFTER `sex`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_newsletter_user` CHANGE `title` `title` INT UNSIGNED NOT NULL";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrTitles = array();
	$query = "SELECT `id`, `title` FROM `".DBPREFIX."module_newsletter_user_title` WHERE `title` = '".implode('\' OR `title` = \'', array_keys($arrTitleFields))."'";
	$objTitle = $objDatabase->Execute($query);
	if ($objTitle !== false) {
		while (!$objTitle->EOF) {
			$arrTitles[$arrTitleFields[$objTitle->fields['title']]] = $objTitle->fields['id'];
			$objTitle->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT `id`, `sex` FROM `".DBPREFIX."module_newsletter_user` WHERE `title` = 0 AND `sex` != ''";
	while (1) {
    	$objUser = $objDatabase->SelectLimit($query, 10);
    	if ($objUser !== false) {
    		if ($objUser->RecordCount() == 0) {
    			// all datasets have been upgraded, so leave this loop
    			break;
    		} else {
    			while (!$objUser->EOF) {
					$subQuery = "UPDATE `".DBPREFIX."module_newsletter_user` SET `title` = ".$arrTitles[$objUser->fields['sex']]." WHERE `id` = ".$objUser->fields['id'];
					if ($objDatabase->Execute($subQuery) === false) {
						return _databaseError($subQuery, $objDatabase->ErrorMsg());
					}
    				$objUser->MoveNext();
    			}
    		}
    	} else {
    		return _databaseError($query, $objDatabase->ErrorMsg());
    	}
	}

	// this must be done after the previous steps
	$arrTitleFields = array(
		'Dear Ms',
		'Dear Mr',
		'Madame',
		'Monsieur'
	);

	foreach ($arrTitleFields as $field) {
		$query = "SELECT 1 FROM `".DBPREFIX."module_newsletter_user_title` WHERE `title` = '".$field."'";
		$objTitle = $objDatabase->SelectLimit($query, 1);
		if ($objTitle !== false) {
			if ($objTitle->RecordCount() == 0) {
				$query = "INSERT INTO `".DBPREFIX."module_newsletter_user_title` (`title`) VALUES ('".$field."')";
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if ($objUpdate->_isNewerVersion($_CONFIG['coreCmsVersion'], '1.1.0')) {
		$arrModules = array();
		$query = "SELECT `id`, `name` FROM `".DBPREFIX."modules`";
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$arrModules[$objResult->fields['id']] = $objResult->fields['name'];
				$objResult->MoveNext();
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		$query = "
    		SELECT
	    		c.`id`,
	    		c.`content`,
	    		c.`title`,
	    		c.`metatitle`,
	    		c.`metadesc`,
	    		c.`metakeys`,
	    		c.`metarobots`,
	    		c.`css_name`,
	    		c.`redirect`,
	    		c.`expertmode`,
	    		n.`catid`,
	    		n.`parcat`,
	    		n.`catname`,
	    		n.`target`,
	    		n.`displayorder`,
	    		n.`displaystatus`,
	    		n.`cachingstatus`,
	    		n.`cmd`,
	    		n.`lang`,
	    		n.`module`,
	    		n.`startdate`,
	    		n.`enddate`,
	    		n.`protected`,
	    		n.`frontend_access_id`,
	    		n.`backend_access_id`,
	    		n.`themes_id`
    		FROM `".DBPREFIX."content` AS c
    		INNER JOIN `".DBPREFIX."content_navigation` AS n ON n.`catid` = c.`id`
    		WHERE n.`module` = 4 AND (n.`cmd` = '' OR n.`cmd` = 'subscribe' OR n.`cmd` = 'profile') AND n.`username` != 'sys_update'";
    	$objContent = $objDatabase->Execute($query);
    	if ($objContent !== false) {
    		$arrFailedPages = array();
    		while (!$objContent->EOF) {
    			$newContent = str_replace(
    				array('{TXT_NEWSLETTER_TITLE}', '{NEWSLETTER_TITLE_F}', '{NEWSLETTER_TITLE_M}', 'name="title"', "name='title'"),
    				array('{TXT_NEWSLETTER_SEX}', '{NEWSLETTER_SEX_F}', '{NEWSLETTER_SEX_M}', 'name="sex"', "name='sex'"),
    				$objContent->fields['content']
    			);
    			$query = "UPDATE `".DBPREFIX."content` SET `content` = '".addslashes($newContent)."' WHERE `id` = ".$objContent->fields['id'];
    			if ($objDatabase->Execute($query) === false) {
    				$s = isset($arrModules[$objContent->fields['module']]) ? $arrModules[$objContent->fields['module']] : '';
					$c = $objContent->fields['cmd'];
					$section = ($s=="") ? "" : "&amp;section=$s";
					$cmd = ($c=="") ? "" : "&amp;cmd=$c";

					switch ($s) {
						case 'gallery':
    						$query = "SELECT `id`, `catid` FROM `".DBPREFIX."module_gallery_pictures`";
    						$objGallery = $objDatabase->SelectLimit($query, 1);
    						if ($objGallery !== false) {
								if ($objGallery->RecordCount() == 1) {
									$s .= "&amp;cid=".$objGallery->fields['catid']."&amp;pId=".$objGallery->fields['id'];
								}
    						} else {
    							return _databaseError($query, $objDatabase->ErrorMsg());
							}
							break;

						default:
							break;
					}

					$link = (!empty($s)) ? "?section=".$s.$cmd : "?page=".$objContent->fields['catid'].$section.$cmd;
    				$arrFailedPages[$objContent->fields['id']] = array('title' => $objContent->fields['catname'], 'link' => 'index.php'.$link.'&amp;langId='.$objContent->fields['lang']);
    			} else {
	    			$objDatabase->Execute("UPDATE `".DBPREFIX."content_navigation_history` SET `is_active` = '0' WHERE `catid` = ".$objContent->fields['id']);
	    			$objDatabase->Execute("
	    				INSERT INTO `".DBPREFIX."content_navigation_history`
						SET
							`is_active` = '1',
							`catid` = ".$objContent->fields['id'].",
							`parcat` = ".$objContent->fields['parcat'].",
							`catname` = '".addslashes($objContent->fields['catname'])."',
							`target` = '".$objContent->fields['target']."',
							`displayorder` = ".$objContent->fields['displayorder'].",
							`displaystatus` = '".$objContent->fields['displaystatus']."',
							`cachingstatus` = '".$objContent->fields['cachingstatus']."',
							`username` = 'sys_update',
							`changelog` = ".time().",
							`cmd` = '".$objContent->fields['cmd']."',
							`lang` = ".$objContent->fields['lang'].",
							`module` = ".$objContent->fields['module'].",
							`startdate` = '".$objContent->fields['startdate']."',
							`enddate` = '".$objContent->fields['enddate']."',
							`protected` = ".$objContent->fields['protected'].",
							`frontend_access_id` = ".$objContent->fields['frontend_access_id'].",
							`backend_access_id` = ".$objContent->fields['backend_access_id'].",
							`themes_id` = ".$objContent->fields['themes_id']
					);

					$historyId = $objDatabase->Insert_ID();

					$objDatabase->Execute("
						INSERT INTO `".DBPREFIX."content_history`
						SET
							`id` = ".$historyId.",
							`page_id` = ".$objContent->fields['id'].",
							`content` = '".addslashes($newContent)."',
							`title` = '".addslashes($objContent->fields['title'])."',
							`metatitle` = '".addslashes($objContent->fields['metatitle'])."',
							`metadesc` = '".addslashes($objContent->fields['metadesc'])."',
							`metakeys` = '".addslashes($objContent->fields['metakeys'])."',
							`metarobots` = '".addslashes($objContent->fields['metarobots'])."',
							`css_name` = '".addslashes($objContent->fields['css_name'])."',
							`redirect` = '".addslashes($objContent->fields['redirect'])."',
							`expertmode` = '".$objContent->fields['expertmode']."'
					");

					$objDatabase->Execute("
						INSERT INTO	`".DBPREFIX."content_logfile`
						SET
							`action` = 'update',
							`history_id` = ".$historyId.",
							`is_validated` = '1'
					");
    			}

    			$objContent->MoveNext();
    		}

    		if (count($arrFailedPages)) {
    			setUpdateMsg($_ARRAYLANG['TXT_UNABLE_APPLY_NEW_NEWSLETTER_LAYOUT']);

        			$pages = '<ul>';
        			foreach ($arrFailedPages as $arrPage) {
        				$pages .= "<li><a href='".$arrPage['link']."' target='_blank'>".$arrPage['title']." (".$arrPage['link'].")</a></li>";
        			}
        			$pages .= '</ul>';
        			setUpdateMsg($pages);
    		}
    	} else {
    		return _databaseError($query, $objDatabase->ErrorMsg());
    	}
	}

	$query = "SELECT setname FROM ".DBPREFIX."module_newsletter_settings WHERE setname='defUnsubscribe'";
	$objConfig = $objDatabase->SelectLimit($query, 1);
	if ($objConfig !== false) {
	 	if ($objConfig->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_newsletter_settings` (`setname`, `setvalue`, `status`) values ('defUnsubscribe', '1', '1')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
	 	}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (in_array(DBPREFIX."module_newsletter_system", $arrTables)) {
		$query = "SELECT sysvalue FROM ".DBPREFIX."module_newsletter_system WHERE sysname='defUnsubscribe'";
		$objConfig = $objDatabase->SelectLimit($query, 1);
		if ($objConfig !== false) {
		 	$tmpValue = $objConfig->fields['sysvalue'];
		 	$query = "UPDATE ".DBPREFIX."module_newsletter_settings SET `setvalue`=".$tmpValue." WHERE setname='defUnsubscribe'";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			} else {
				$query = "DROP TABLE ".DBPREFIX."module_newsletter_system";
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

    return true;
}
?>