<?php
function _votingUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrTables = $objDatabase->MetaTables('TABLES');
	if (!$arrTables) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (!in_array(DBPREFIX.'voting_email', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."voting_email` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
			`email` VARCHAR( 255 ) NOT NULL ,
			PRIMARY KEY ( `id` ) ,
			UNIQUE (
			`email`
			)
			) ENGINE = MYISAM";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array(DBPREFIX.'voting_rel_email_system', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."voting_rel_email_system` (
			`email_id` INT UNSIGNED NOT NULL ,
			`system_id` INT UNSIGNED NOT NULL ,
			UNIQUE (
			`email_id` ,
			`system_id`
			)
			) ENGINE = MYISAM";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."voting_system");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'voting_system'));
		return false;
	}
	if (!in_array('submit_check', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."voting_system` ADD `submit_check` ENUM( 'cookie', 'email' ) DEFAULT 'cookie' NOT NULL AFTER `status`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "ALTER TABLE `".DBPREFIX."voting_system` CHANGE `question` `question` text NULL";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."voting_rel_email_system");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'voting_rel_email_system'));
		return false;
	}
	if (!in_array('voting_id', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."voting_rel_email_system` ADD `voting_id` INT UNSIGNED NOT NULL , ADD `valid` ENUM( '0', '1' ) NOT NULL";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."voting_email");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'voting_email'));
		return false;
	}
	if (!in_array('valid', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."voting_email` ADD `valid` ENUM( '0', '1' ) NOT NULL";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	return true;
}
?>
